<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="cokr.xit.fims.cmmn.dao.StngMapper">

<select id="selectDefaultTask" parameterType="string" resultType="dataobject">
/* 사용자 기본업무 조회 (stngMapper.selectDefaultTask) */
SELECT TM.TASK_MTCHG_ID
     , TM.TASK_SE_CD
  FROM TB_TASK_MTCHG TM
 WHERE TM.USER_ID = #{userId}
   AND TM.USE_YN = 'Y'
</select>

<select id="selectUserStng" parameterType="string" resultType="dataobject">
/* 사용자 설정정보 조회 (stngMapper.selectUserStng) */
SELECT USER_ID
     , '' AS 'DEFAULT_TASK_SE_CD'
  FROM TB_USER
 WHERE USER_ID = #{userId}
</select>

<select id="selectDeptStng" parameterType="string" resultType="dataobject">
/* 부서 설정정보 조회 (stngMapper.selectDeptStng) */
SELECT DEPT_CD
     , DEPT_NM
     , DEPT_TELNO        <!-- 부서 전화번호 -->
     , DEPT_FXNO         <!-- 부서 팩스번호 -->
     , CVLCPT_LINK_SE_CD <!-- 민원 연계 구분 코드 -->
     , VRBACNT_LINK_SE_CD<!-- 가상계좌 연계 구분 코드 -->
     , PSTOFC_NM         <!-- 우체국 명 -->
     , RG_NO_HEADER      <!-- 등기 번호 헤더 -->
     , SNDNG_LINK_SE_CD  <!-- 발송 연계 구분 코드 -->
     , EGP_CON_ORG       <!-- E그린 외부기관구분코드 -->
     , EGP_RCEPT_ID      <!-- E그린 접수우체국국기호 -->
     , EGP_APVL_NB       <!-- E그린 후납계약승인번호 -->
     , EGP_ESB_PATH      <!-- E그린 ESB경로 -->
     , EGP_POST_INST_ID  <!-- E그린 우정정보센터 기관 ID -->
     , EGP_CERT_CN       <!-- E그린 인증서CN -->
     , ENS_INTERFACE_ID  <!-- 세외수입 인터페이스ID -->
     , ENS_SOURCE_CD     <!-- 세외수입 소스코드 -->
     , ENS_TARGET_CD     <!-- 세외수입 타겟코드 -->
     , ENS_URL           <!-- 세외수입 URL -->
     , NXRP_LINK_YN      <!-- 세외수입 연계 여부 -->
     , NXRP_RGN_SE_CD    <!-- 세외수입 지역 구분 코드 -->
     , DTBN_BANK_NM      <!-- 교부 은행 명 -->
     , DTBN_ACTNO        <!-- 교부 계좌번호 -->
     , DOC_HEADER        <!-- 문서 머릿말 -->
     , SRVR_OS           <!-- 서버 OS -->
  FROM TB_DEPT
 WHERE DEPT_CD = #{deptCd}
</select>

<select id="selectSggStng" parameterType="string" resultType="dataobject">
/* 시군구 설정정보 조회 (stngMapper.selectSggStng) */
SELECT SGG_CD           <!-- 시군구 코드 -->
     , SGG_NM           <!-- 시군구 명 -->
     , INST_SE_CD       <!-- 기관 구분 코드 -->
     , INST_CD          <!-- 기관 코드 -->
     , INST_NM          <!-- 기관 명 -->
     , (CASE
        WHEN INST_DADDR IS NULL OR INST_DADDR = ''
        THEN INST_ADDR
        ELSE CONCAT(INST_ADDR,' ',INST_DADDR)
        END) AS INST_FULL_ADDR <!-- 기관 전체 주소 -->
     , INST_ADDR        <!-- 기관 기본 주소 -->
     , INST_DADDR       <!-- 기관 상세 주소 -->
     , INST_ZIP         <!-- 기관 우편번호 -->
     , SYMBOL_FILE_PATH <!-- 상징 파일 경로 -->
     , SYMBOL_FILE_NM   <!-- 상징 파일 명 -->
     , LOGO_FILE_PATH   <!-- 로고 파일 경로 -->
     , LOGO_FILE_NM     <!-- 로고 파일 명 -->
     , OFFCS_FILE_PATH  <!-- 직인 파일 경로 -->
     , OFFCS_FILE_NM    <!-- 직인 파일 명 -->
  FROM TB_SGG
 WHERE SGG_CD = #{sggCd}
</select>

<update id="updateDtbnActno" parameterType="map">
/* 교부 계좌번호 변경 (stngMapper.updateDtbnActno) */
UPDATE TB_DEPT
   SET MDFR         = #{mdfr}
     , MDFCN_DT     = <include refid="utility.now" />
     , DTBN_BANK_NM = #{dtbnBankNm}
     , DTBN_ACTNO   = #{dtbnActno}
 WHERE DEPT_CD = #{deptCd}
</update>

<insert id="insertDefaultTask" parameterType="map">
/* 사용자 기본 업무 등록 (stngMapper.insertDefaultTask) */
<selectKey resultType="string" keyProperty="taskMtchgId" keyColumn="NEW_ID" order="BEFORE">
	<include refid="numbering.key">
		<property name="TABLE_NAME" value="TB_TASK_MTCHG" />
		<property name="TABLE_KEY" value="TASK_MTCHG_ID" />
		<property name="pad" value="10" />
	</include>
</selectKey>
INSERT 
  INTO TB_TASK_MTCHG (
       TASK_MTCHG_ID
     , USER_ID
     , TASK_SE_CD
     , USE_YN
     , REG_DT
     , RGTR
  ) VALUES (
       #{taskMtchgId}
     , #{userId}
     , #{taskSeCd}
     , 'Y'
     , <include refid="utility.now" />
     , #{rgtr}
  )
</insert>

<update id="updateDefaultTask" parameterType="map">
/* 사용자 기본 업무 변경 (stngMapper.updateDefaultTask) */
UPDATE TB_TASK_MTCHG
   SET MDFR         = #{mdfr}
     , MDFCN_DT     = <include refid="utility.now" />
     , TASK_SE_CD   = #{taskSeCd}
 WHERE TASK_MTCHG_ID = #{taskMtchgId}
</update>

</mapper>